var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useRef, useState } from "react";
import styled from "styled-components";
import { darkgray50, gray70, redpink50, ic_common_warning_16_red, } from "../../common";
export var Form;
(function (Form) {
    Form.Text = function (_a) {
        var title = _a.title, placeholder = _a.placeholder, validation = _a.validation, space = _a.space;
        var _b = useState(false), focus = _b[0], setFocus = _b[1];
        var _c = useState(true), valid = _c[0], setValid = _c[1];
        var inputRef = useRef(null);
        var titleRef = useRef(null);
        var handleFocus = function () {
            setFocus(true);
        };
        var handleBlur = function () {
            if (inputRef.current && !inputRef.current.value) {
                setFocus(false);
            }
        };
        var handleChange = function (event) {
            if (validation && validation.regExp.test(event.target.value)) {
                validation.handleValid();
                setValid(true);
            }
            else {
                console.log("?");
                setValid(false);
            }
        };
        return (_jsxs(Container, __assign({ space: space }, { children: [_jsx(Title, __assign({ ref: titleRef, focus: focus }, { children: title }), void 0),
                _jsx(InputText, { ref: inputRef, name: title, placeholder: focus ? placeholder : "", onFocus: handleFocus, onBlur: handleBlur, onChange: handleChange }, void 0),
                validation && !valid && (_jsx(InvalidMessage, { children: validation.invalidMessage }, void 0))] }), void 0));
    };
    Form.Select = function (_a) {
        var title = _a.title, options = _a.options, validation = _a.validation, space = _a.space;
        var _b = useState(""), selected = _b[0], setSelected = _b[1];
        var optionRef = useRef(null);
        var handleFocus = function () {
            if (optionRef.current) {
                var _a = optionRef.current, style = _a.style, childElementCount = _a.childElementCount;
                style.height = 42.5 * childElementCount + "px";
                style.padding = "8px 0";
            }
        };
        var handleBlur = function () {
            setTimeout(function () {
                if (optionRef.current) {
                    var style = optionRef.current.style;
                    style.height = "0";
                    style.padding = "0";
                }
            }, 100);
        };
        return (_jsxs(Container, __assign({ space: space }, { children: [_jsx(Title, __assign({ focus: selected ? true : false }, { children: title }), void 0),
                _jsx(InputSelect, { name: title, value: selected, onChange: function () { }, onFocus: handleFocus, onBlur: handleBlur }, void 0),
                _jsx(Options, __assign({ ref: optionRef }, { children: options === null || options === void 0 ? void 0 : options.map(function (option, index) {
                        return (_jsx(Option, __assign({ onClick: function () { return setSelected(option.value); } }, { children: option.value }), index));
                    }) }), void 0),
                validation && validation.show && (_jsx(InvalidMessage, { children: validation.invalidMessage }, void 0))] }), void 0));
    };
})(Form || (Form = {}));
var Container = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: relative;\n  width: 100%;\n  height: 71.5px;\n  margin: ", "px;\n"], ["\n  position: relative;\n  width: 100%;\n  height: 71.5px;\n  margin: ", "px;\n"])), function (_a) {
    var space = _a.space;
    return space !== null && space !== void 0 ? space : 20;
});
var Input = styled.input(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  position: absolute;\n  width: inherit;\n  font-size: 22px;\n  padding: 20px 0;\n  outline: none;\n  border: none;\n  border-bottom: 2px solid #f5f7f7;\n  background: none;\n\n  &:focus {\n    border-bottom-color: ", ";\n  }\n"], ["\n  position: absolute;\n  width: inherit;\n  font-size: 22px;\n  padding: 20px 0;\n  outline: none;\n  border: none;\n  border-bottom: 2px solid #f5f7f7;\n  background: none;\n\n  &:focus {\n    border-bottom-color: ", ";\n  }\n"])), redpink50);
var InputText = styled(Input).attrs({ type: "text" })(templateObject_3 || (templateObject_3 = __makeTemplateObject([""], [""])));
var InputSelect = styled(Input)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  caret-color: transparent;\n"], ["\n  caret-color: transparent;\n"])));
var Options = styled.ul(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  transition: 0.2s;\n  font-size: 14px;\n  position: absolute;\n  top: 100%;\n  width: 100%;\n  height: 0;\n  max-height: 300px;\n  background: #fff;\n  border-radius: 0px 0px 5px 5px;\n  box-shadow: rgb(0 0 0 / 20%) 0px 2px 5px 0px;\n  z-Index: 1;\n\n  margin: 0;\n  padding: 0;\n  \n  overflow-y: scroll;\n  list-style-type: none;\n}"], ["\n  transition: 0.2s;\n  font-size: 14px;\n  position: absolute;\n  top: 100%;\n  width: 100%;\n  height: 0;\n  max-height: 300px;\n  background: #fff;\n  border-radius: 0px 0px 5px 5px;\n  box-shadow: rgb(0 0 0 / 20%) 0px 2px 5px 0px;\n  z-Index: 1;\n\n  margin: 0;\n  padding: 0;\n  \n  overflow-y: scroll;\n  list-style-type: none;\n}"])));
var Option = styled.li(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n  padding: 12px;\n  &:hover {\n    background: #f5f7f7;\n  }\n"], ["\n  padding: 12px;\n  &:hover {\n    background: #f5f7f7;\n  }\n"])));
var Title = styled.span(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n  ", "\n"], ["\n  ",
    "\n"])), function (_a) {
    var focus = _a.focus;
    return "\n        position: absolute;\n        font-size: " + (focus ? "13px" : "22px") + ";\n        top: 20px;\n        left: 0;\n        color: " + (focus ? darkgray50 : gray70) + ";\n        transition: 0.2s;\n        transform: translateY(" + (focus ? "-25px" : "0") + ");\n\n        &:after {\n            content: \"*\";\n            position: absolute;\n            top: -0.2em;\n            right: -0.6em;\n            color: " + redpink50 + ";\n        }\n    ";
});
var InvalidMessage = styled.span(templateObject_8 || (templateObject_8 = __makeTemplateObject(["\n  position: absolute;\n  display: inline-flex;\n  bottom: -25px;\n  left: 0;\n  color: ", ";\n  font-size: 12px;\n  &:before {\n    content: \"\";\n    width: 16px;\n    height: 16px;\n    margin-right: 4px;\n    background: no-repeat center/cover ", ";\n  }\n"], ["\n  position: absolute;\n  display: inline-flex;\n  bottom: -25px;\n  left: 0;\n  color: ", ";\n  font-size: 12px;\n  &:before {\n    content: \"\";\n    width: 16px;\n    height: 16px;\n    margin-right: 4px;\n    background: no-repeat center/cover ", ";\n  }\n"])), redpink50, ic_common_warning_16_red);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8;
